CGAL 6.2 - 3D Isosurfacing: CGAL::Isosurfacing::Finite_difference_gradient_3< GeomTraits > Class Template Reference

CGAL 6.2 - 3D Isosurfacing

Loading...
Searching...
No Matches
List of all members | Public Types | Public Member Functions
CGAL::Isosurfacing::Finite_difference_gradient_3< GeomTraits > Class Template Reference
Reference Manual » Value and Gradient Fields

`#include <CGAL/Isosurfacing_3/Finite_difference_gradient_3.h>`

## Definition

template<typename GeomTraits>
class CGAL::Isosurfacing::Finite_difference_gradient_3< GeomTraits >

Class template for a gradient that is calculated using finite differences.

Is model of
  `IsosurfacingGradientField_3`

This gradient function evaluates a value function at six points that are a given distance `delta` away from the queried point along the Cartesian axes.

Template Parameters

  GeomTraits | must be a model of `IsosurfacingTraits_3`.

Examples
  Isosurfacing_3/contouring_inrimage.cpp, Isosurfacing_3/contouring_mesh_offset.cpp, and Isosurfacing_3/contouring_vtk_image.cpp.

## Public Types
using | Geom_traits = GeomTraits
using | FT = typename Geom_traits::FT
using | Point_3 = typename Geom_traits::Point_3
using | Vector_3 = typename Geom_traits::Vector_3

## Public Member Functions
template<typename ValueFunction >
| Finite_difference_gradient_3 (const ValueFunction &function, const FT delta, const Geom_traits &gt=Geom_traits())
| creates a new instance of this gradient class.
Vector_3 | operator() (const Point_3 &p) const
| returns the value the gradient at a point in 3D space.

## Constructor & Destructor Documentation

## ◆ Finite_difference_gradient_3()

template<typename GeomTraits >
template<typename ValueFunction >

CGAL::Isosurfacing::Finite_difference_gradient_3< GeomTraits >::Finite_difference_gradient_3 | ( | const ValueFunction & | function,
|  | const FT | delta,
|  | const Geom_traits & | gt = `Geom_traits()`
| ) |  |

creates a new instance of this gradient class.

Template Parameters

  ValueFunction | must be a model of `IsosurfacingValueField_3`.

Parameters

  function | the function giving the scalar value at each point
  delta | the distance between samples for calculating the finite differences
  gt | the geometric traits class

## Member Function Documentation

## ◆ operator()()

template<typename GeomTraits >

Vector_3 CGAL::Isosurfacing::Finite_difference_gradient_3< GeomTraits >::operator() | ( | const Point_3 & | p | ) | const

returns the value the gradient at a point in 3D space.

Parameters

  p | the point at which the gradient is computed.